#!/bin/sh
#grab the link to the selected/right-clicked file
self=`readlink -en "$@"`
base=`dirname "$self"`

cd "$base"

FILE="$@"
extension="${1##*.}"
FILEBASE=$(basename "$FILE" .$extension)
echo > '/root/pd-externals/pd2plantuml/pd2plantuml_mindmap.html'
#grab/write a list of all the "obj"'s embedded in the file
grep obj "$FILEBASE.pd" >  /root/pd-externals/pd2plantuml/tmp/pd2plantuml_abs.txt

#grab/write a list of all the supatches, "pd" objects, embedded in the file
grep ' pd ' "$FILEBASE.pd" >  /root/pd-externals/pd2plantuml/tmp/pd2plantuml_subs.txt

#clean up the filebase name to remove all plantuml reserved characters
CLEANFILEBASE=`echo "$FILEBASE" | sed 's/\~//'`

#write the html file header (note: this whole script could be done embedded as javascript process but I don't have the capacity to work that out right now
echo  '<html>
<head>
<script type="text/javascript" src="res/jquery.js"></script>
<script type="text/javascript" src="res/jquery_plantuml.js"></script>

</head>
<body>
<p>MindMap(UMLDiagram) of: </p>
<hr>'  >> '/root/pd-externals/pd2plantuml/pd2plantuml_mindmap.html'

#write the 3 img section headers
#########################
#write the "natives" and abstractions img sections
#########################
echo '<img id="natives" uml="
skinparam usecase {
	BackgroundColor DarkSeaGreen
	BorderColor DarkSlateGray

	BackgroundColor<< native >> red
	BorderColor<< native >> red

	BackgroundColor<< subpatches >> yellow
	BorderColor<< subpatches >> yellow

	BackgroundColor<< abs >> green
	BorderColor<< abs >> green

	ArrowColor Olive
	ActorBorderColor black
	ActorFontName Courier

	ActorBackgroundColor<< patch >> Gold
}
' > '/root/pd-externals/pd2plantuml/tmp/pd2plantuml_natives.txt'
#the main actor, i.e. the root/selected file as an actor
echo "$CLEANFILEBASE << patch >>" >>  '/root/pd-externals/pd2plantuml/tmp/pd2plantuml_natives.txt'
#########################
#end: write the "natives" img section
#########################

#########################
#write the "abs" img section
#########################
echo '<img id="abs" uml="
skinparam usecase {
	BackgroundColor DarkSeaGreen
	BorderColor DarkSlateGray

	BackgroundColor<< native >> red
	BorderColor<< native >> red

	BackgroundColor<< subpatches >> yellow
	BorderColor<< subpatches >> yellow

	BackgroundColor<< abs >> green
	BorderColor<< abs >> green

	ArrowColor Olive
	ActorBorderColor black
	ActorFontName Courier

	ActorBackgroundColor<< patch >> Gold
}
' > '/root/pd-externals/pd2plantuml/tmp/pd2plantuml_abstractions.txt'
#the main actor, i.e. the root/selected file as an actor
echo "$CLEANFILEBASE << patch >>" >>  '/root/pd-externals/pd2plantuml/tmp/pd2plantuml_abstractions.txt'
#########################
#end: write the "abs" img section
#########################

#########################
#write the "subs" img section
#########################

echo '<img id="subs" uml="
skinparam usecase {
	BackgroundColor DarkSeaGreen
	BorderColor DarkSlateGray

	BackgroundColor<< native >> red
	BorderColor<< native >> red

	BackgroundColor<< subpatches >> yellow
	BorderColor<< subpatches >> yellow

	BackgroundColor<< abs >> green
	BorderColor<< abs >> green

	ArrowColor Olive
	ActorBorderColor black
	ActorFontName Courier

	ActorBackgroundColor<< patch >> Gold
}
' > '/root/pd-externals/pd2plantuml/tmp/pd2plantuml_subpatches.txt'
#the main actor, i.e. the root/selected file as an actor
echo "$CLEANFILEBASE << patch >>" >>  '/root/pd-externals/pd2plantuml/tmp/pd2plantuml_subpatches.txt'





#write and seperate out the objects into natives and abstractions
while read line;
do 
	Object=`echo "$line" | awk '{print $5}' | sed 's/;//'`

#filter out all inborn vanilla objects
	while read lineObjs;
	do
		if [ "$Object" == "$lineObjs" ] ;
		then	
			isObj=`echo "true"`
			break
		else
			isObj=`echo "false"`
		fi
	done < /root/pd-externals/pd2plantuml/res/objectlist.txt
	#xmessage "$isObj"
	if [ "$isObj" == "false" ] ;
	then
		Object2=`echo "$line" | awk '{print "("$5")"}' | sed 's/;//'`
		echo "$Object2<< abs >>" >>  '/root/pd-externals/pd2plantuml/tmp/pd2plantuml_abstractions.txt'
		echo "$CLEANFILEBASE --> $Object2" >>  '/root/pd-externals/pd2plantuml/tmp/pd2plantuml_abstractions.txt'
	else
		Object3=`echo "$line" | awk '{print "("$5")"}' | sed 's/;//'`
		echo "$Object3 << native >>" >>  '/root/pd-externals/pd2plantuml/tmp/pd2plantuml_natives.txt'
		echo "$CLEANFILEBASE --> $Object3" >>  '/root/pd-externals/pd2plantuml/tmp/pd2plantuml_natives.txt'
	fi
done < /root/pd-externals/pd2plantuml/tmp/pd2plantuml_abs.txt

echo '"><br/>' >> '/root/pd-externals/pd2plantuml/tmp/pd2plantuml_natives.txt'
echo '"><br/>' >> '/root/pd-externals/pd2plantuml/tmp/pd2plantuml_abstractions.txt'

#write the subs file
while read line;
do 
	Sub=`echo "$line" | awk '{print "(pd "$6")"}'`
	echo "$Sub << subpatches >>" >>  '/root/pd-externals/pd2plantuml/tmp/pd2plantuml_subpatches.txt'
	echo "$CLEANFILEBASE ---> $Sub" >>  '/root/pd-externals/pd2plantuml/tmp/pd2plantuml_subpatches.txt'
done < /root/pd-externals/pd2plantuml/tmp/pd2plantuml_subs.txt

echo '"><br/>' >> '/root/pd-externals/pd2plantuml/tmp/pd2plantuml_subpatches.txt'

cat '/root/pd-externals/pd2plantuml/tmp/pd2plantuml_natives.txt'  >> '/root/pd-externals/pd2plantuml/pd2plantuml_mindmap.html'
cat '/root/pd-externals/pd2plantuml/tmp/pd2plantuml_subpatches.txt'  >> '/root/pd-externals/pd2plantuml/pd2plantuml_mindmap.html'
cat '/root/pd-externals/pd2plantuml/tmp/pd2plantuml_abstractions.txt'  >> '/root/pd-externals/pd2plantuml/pd2plantuml_mindmap.html'

echo '<hr>
</body>
</html>'  >> '/root/pd-externals/pd2plantuml/pd2plantuml_mindmap.html'

defaultbrowser '/root/pd-externals/pd2plantuml/pd2plantuml_mindmap.html'